//GeoGet 2
//--------------------------------------------------------------------------------------------------------------
//DrakMrak (verze 1.1.0 - 28.5.2010) - Testovno s Magellan Triton 1500
//--------------------------------------------------------------------------------------------------------------
//Pevodn makro pro pevod vybranch bod - ke z geogetu do Magellan GPS (Triton)
//K nahrn do GPS slou program VantagePoint - kde se pes symbol v levm hornm rohu
//z menu vybere funkce Load GPX File to My GPS - direkt nahrn GPX souboru do GPS a tm se vybran GPX nahraje
//Makro - odstran dsledn etinu a html plus pid pr drobnost jako napklad do short message
//--------------------------------------------------------------------------------------------------------------
//vlo krtkou informaci o kei typu [TR11+]... T - Tradika, R - Regular, 1,1 difficulty a tern  
//[+/-/*] enable/disable/archive
//--------------------------------------------------------------------------------------------------------------
//-- takto vytvoen GPX nejde naimportovat pmo do VantagePointu (pro zatm nevm ale nejde !!)
//-- nicmn z pipojen GPS si mete kee naimportovat zpt do VP je to sice kostrbat ale budi (zatm) :-)
//--------------------------------------------------------------------------------------------------------------
//-- 1.0 - prvn release
//-- 1.1 - doplnno vyhlazen text (odstrann pebytench znak CRLF) kompaktn text
//       - pidno ID kee do short-message GCxxxxx - [TR11+] - lep info o kei
//       - pidny poznmky do short-message - pokud mte v GG poznmku hod se do short-message
//       - ped nzev cache pidn symbol aktivity +| nebo -| nebo *| lep pehlednost v seznamu
//       - vychytny drobnosti v GPX poskracovno co to jde
//-- 1.2 - oprava symbolu aktivity
//       - pridany logy poslednich 5 do listingu nakonec
//-------------------------------------------------------------------------------------------------------------- 

function ExportExtension: string;
begin
  result := 'GPX';
end;

function ExportDescription: string;
begin
  Result := 'Geoget GPX VP (Magellan Triton VP GPX)';
end;

function ExportHeader: string;
begin
  Result := '<?xml version="1.0" encoding="UTF-8"?>' + CRLF;
  Result := Result + '<gpx xmlns:xsd="http://www.w3.org/2001/XMLSchema"'
                   + ' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'
				   + ' version="1.0" creator="Magellan UDS library"'
				   + ' xsi:schemaLocation="http://www.topografix.com/GPX/1/0 http://www.topografix.com/GPX/1/0/gpx.xsd http://www.groundspeak.com/cache/1/0/1 http://www.groundspeak.com/cache/1/0/1/cache.xsd"'
				   + ' xmlns="http://www.topografix.com/GPX/1/0">' + CRLF;
end;

function ExportFooter: string;
begin
  Result := '</gpx>' + CRLF;
end;

{function m2feet(m: string) : string;
var
  height : extended;
begin
  height := strtofl(m) / 0.3048;
  Result  := inttostr(round(height));
end;}

//Funkce kter odstran pebyten znaky crlf - text na GPS je pak kompaktnj a krat nemus se tolik listovat
//Ponechv se jedno CRLF zbytek se odstran
function CrlfKiller(txt : string) : string;
var
  res, ps : string;
begin
  res := '';
  if Length(txt) > 0 then begin
    While Length(txt) > 0 do begin 
	  ps := Fetch(txt, CRLF);
	  if Length(ps) > 0 then begin
		res := res + ps + CRLF;
	  end
	end;
  end;
  Result := res;
end;

function ExportPoint: string;
var
  s, ww, wl, cmt, log: string;
  n, cnt: integer;
  //l: TStringlist;
  //lv: TStringlist;
  TAB: char;
begin
  TAB := #9;
  Result := '';
  log := '';
  //Export for Geocaches
  if GC.IsListed then
  begin
    Result := Result + TAB + '<wpt lat="' + GC.Lat + '" lon="' + GC.Lon + '">' + CRLF;
    Result := Result + TAB + TAB + '<time>'
					 + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz"Z', GC.Hidden)
					 + '</time>' + CRLF;
	//-----------------------------------------------------------------------------------
	cmt := '';
	Case GC.CacheType of
	  'Cache In Trash Out Event': cmt := cmt + 'C';
	  'Earthcache': cmt := cmt + 'G';
	  'Event Cache': cmt := cmt + 'E';
	  'Letterbox Hybrid': cmt := cmt + 'H';
	  'Lost and Found Event Cache': cmt := cmt + 'Y';
	  'Multi-cache': cmt := cmt + 'M';
	  'Traditional Cache': cmt := cmt + 'T';
	  'Unknown Cache': cmt := cmt + 'U';
	  'Virtual Cache': cmt := cmt + 'V';
	  'Webcam Cache': cmt := cmt + 'W';
	  'Wherigo Cache': cmt := cmt + 'I';
	  'Mega-Event Cache': cmt := cmt + 'Z';	
	  'GPS Adventures Exhibit': cmt := cmt + 'X';
	  'Project APE Cache': cmt := cmt + 'C';
	  else cmt := cmt + '*';
	end;
	//
	Case GC.Size of
	  'Virtual': cmt := cmt + 'V';
	  'Small': cmt := cmt + 'S';
	  'Regular': cmt := cmt + 'R';
	  'Micro': cmt := cmt + 'M';
	  'Not chosen': cmt := cmt + 'N';
	  'Other': cmt := cmt + 'O';
	  'Large': cmt := cmt + 'L';
	  else cmt := cmt + '*';
	end;
	//
	cmt := cmt + Copy(GC.Difficulty,1,1);
	//
	cmt := cmt + Copy(GC.Terrain,1,1);
	//-----------------------------------------------------------------------------------
	if GC.IsDisabled then begin
      s := 'available="false"';
	  wl := '-';
	end
    else begin
      s := 'available="true"';
	  wl := '+';
	end;
    if GC.IsArchived then begin
      s := s + ' archived="true"';
	  ww := '#';
	end
    else begin
      s := s + ' archived="false"';
	  ww := '';
	end;
	if ww = '#' then cmt := cmt + ww
	else cmt := cmt + wl;
	//-------------------------------------------------------------------------------------
	Result := Result + TAB + TAB + '<name>' + GC.ID +'</name>' + CRLF;
	Result := Result + TAB + TAB + '<cmt>' + cmt + '</cmt>' + CRLF;
    Result := Result + TAB + TAB + '<desc>' + XMLEntityEncode(UtfToAscii(GC.Name)) + ' by ' + XMLEntityEncode(UtfToAscii(GC.Author))
					 + ', '  + GC.CacheType + ' (' + GC.Difficulty
					 + '/' + GC.Terrain + ')' +'</desc>' + CRLF;
    Result := Result + TAB + TAB + '<url>' + GC.URL +'</url>' + CRLF;
    Result := Result + TAB + TAB + '<urlname>' + XMLEntityEncode(UtfToAscii(GC.Name)) + '</urlname>' + CRLF;
	{Elevation information from tag}
	//if GC.tagHavecategory('Elevation') then
	//	Result := Result + TAB + TAB + '<elev>' + m2feet(GC.TagValues('Elevation')) + '</elev>' + CRLF;
	//--------------------------------------------------------------------------------------------------		
    if GC.IsFound then
      Result := Result + TAB + TAB + '<sym>Geocache Found</sym>' + CRLF
    else
      Result := Result + TAB + TAB + '<sym>Geocache</sym>' + CRLF;
    Result := Result + TAB + TAB + '<type>Geocache|' + GC.CacheType + '</type>' + CRLF;
	Result := Result + TAB + TAB + '<extensions>' + CRLF;
	s := 'id="' + GC.CacheID +'" ' + s + ' xmlns:groundspeak="http://www.groundspeak.com/cache/1/0/1"';
    Result := Result + TAB + TAB + TAB + '<groundspeak:cache ' + s + '>' + CRLF;
    Result := Result + TAB + TAB + TAB + TAB + '<groundspeak:name>' + wl + '|' + XMLEntityEncode(UtfToAscii(GC.Name)) + '</groundspeak:name>' + CRLF;
    Result := Result + TAB + TAB + TAB + TAB + '<groundspeak:placed_by>' + XMLEntityEncode(UtfToAscii(GC.Author)) +'</groundspeak:placed_by>' + CRLF;
    if GC.OwnerID <> '' then
	   Result := Result + TAB + TAB + TAB + TAB + '<groundspeak:owner id="' + GC.OwnerID + '">'
                    	+ XMLEntityEncode(UtfToAscii(GC.Author)) + '</groundspeak:owner>' + CRLF;
    Result := Result + TAB + TAB + TAB + TAB + '<groundspeak:type>' + GC.CacheType +'</groundspeak:type>' + CRLF;
    Result := Result + TAB + TAB + TAB + TAB + '<groundspeak:container>' + GC.Size +'</groundspeak:container>' + CRLF;
	//nedvm - stejn je nen kde zobrazit
	Result := Result + TAB + TAB + TAB + TAB + '<groundspeak:attributes />' + CRLF;
	//
	ww := GC.Difficulty;
	if Length(ww) = 1 then ww := ww + '.0';
    Result := Result + TAB + TAB + TAB + TAB + '<groundspeak:difficulty>' + ww +'</groundspeak:difficulty>' + CRLF;
	ww := GC.Terrain;
	if Length(ww) = 1 then ww := ww + '.0';
    Result := Result + TAB + TAB + TAB + TAB + '<groundspeak:terrain>' + ww +'</groundspeak:terrain>' + CRLF;
    Result := Result + TAB + TAB + TAB + TAB + '<groundspeak:country>' + UtfToAscii(GC.Country) +'</groundspeak:country>' + CRLF;
    Result := Result + TAB + TAB + TAB + TAB + '<groundspeak:state>' + UtfToAscii(GC.State) +'</groundspeak:state>' + CRLF;
    Result := Result + TAB + TAB + TAB + TAB + '<groundspeak:short_description html="True">' + GC.ID +' - [' + cmt + '] '
	if Length(GC.Comment) > 0 then
		Result := Result + CRLF + Trim(CrlfKiller(XMLEntityEncode(Html2text(UtfToAscii(GC.Comment)))));
	Result := Result + '</groundspeak:short_description>' + CRLF;
    Result := Result + TAB + TAB + TAB + TAB + '<groundspeak:long_description html="True">';
	if Trim(CrlfKiller(XMLEntityEncode(Html2text(UtfToAscii(GC.ShortDescription))))) <> '' then
		Result := Result + Trim(CrlfKiller(XMLEntityEncode(Html2text(UtfToAscii(GC.ShortDescription))))) + CRLF + '---' + CRLF; 
	Result := Result + Trim(CrlfKiller(XMLEntityEncode(Html2text(UtfToAscii(GC.LongDescription))))) + CRLF;
	//----------------------------------------------------------
	cnt := GC.Logs.Count - 1;
	if cnt > 4 then cnt := 4;		//poslednich 5 log
	log := '=========================' + CRLF;
	for n := 0 to cnt do
    begin
		log := log + '[' + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz"Z', GC.Logs[n].Date) + ']' + CRLF;
		log := log + '[' + GC.Logs[n].LogType + ']' + XMLEntityEncode(UtfToAscii(GC.Logs[n].Finder)) + CRLF;
		log := log + XMLEntityEncode(Html2text(UtfToAscii(GC.Logs[n].Text))) + CRLF;
		log := log + '----------' + CRLF;
	end;
	//----------------------------------------------------------
	Result := Result + log + '</groundspeak:long_description>' + CRLF;
    Result := Result + TAB + TAB + TAB + TAB + '<groundspeak:encoded_hints>' + XMLEntityEncode(UtfToAscii(GC.Hint)) +'</groundspeak:encoded_hints>' + CRLF;
    Result := Result + TAB + TAB + TAB + TAB + '<groundspeak:logs />' + CRLF;
	Result := Result + TAB + TAB + TAB + TAB +'<groundspeak:travelbugs />' + CRLF;
    Result := Result + TAB + TAB + TAB +'</groundspeak:cache>' + CRLF;
	Result := Result + TAB + TAB + '</extensions>' + CRLF;
    Result := Result + TAB + '</wpt>' + CRLF;
  end;
  //Export for Waypoints
  for n := 0 to GC.Waypoints.Count - 1 do
    if GC.Waypoints[n].IsListed then
    begin
      Result := Result + TAB +' <wpt lat="' + GC.Waypoints[n].Lat + '" lon="' + GC.Waypoints[n].Lon + '">' + CRLF;
      Result := Result + TAB + TAB + '<time>'
					   + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz"Z', GC.Hidden) + '</time>' + CRLF;
      Result := Result + TAB + TAB + '<name>' + XMLEntityEncode(UtfToAscii(GC.Waypoints[n].ID)) +'</name>' + CRLF;
      Result := Result + TAB + TAB + '<cmt>' + XMLEntityEncode(Html2text(UtfToAscii(GC.Waypoints[n].Description))) +'</cmt>' + CRLF;
      Result := Result + TAB + TAB + '<desc>' + XMLEntityEncode(UtfToAscii(GC.Waypoints[n].Name)) +'</desc>' + CRLF;
      Result := Result + TAB + TAB + '<url>' + GC.Waypoints[n].URL +'</url>' + CRLF;
      Result := Result + TAB + TAB + '<urlname>' + XMLEntityEncode(UtfToAscii(GC.Waypoints[n].Name)) + '</urlname>' + CRLF;
      Result := Result + TAB + TAB + '<sym>' + GC.Waypoints[n].WptType + '</sym>' + CRLF
      Result := Result + TAB + TAB + '<type>Waypoint|' + GC.Waypoints[n].WptType + '</type>' + CRLF;
      Result := Result + TAB + '</wpt>' + CRLF + CRLF;
    end;
end;

